/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: main.c 590 2014-12-08 04:31:28Z coas-nagasima $
 */

/* 
 *  TvvO(1)̖{
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <sil.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "main.h"
#include "echonet_cfg.h"
#ifdef __CA850__
#include "v850_ca850/v850esjh3e.h"
#else
#include "v850_msvc/v850esjx3e.h"
#endif

uint8_t mac_addr[6] = { 0x00, 0x30, 0x13, 0x06, 0x62, 0xB9 };

#define MAKER_CODE	0x00, 0x00, 0xB3	/* TOPPERSvWFNg */

/* m[hvt@CIuWFNg */
struct node_profile_object_t local_node_data = {
	0x30,	/*  */
	{ 0x01, 0x0A, 0x01, 0x00 },	/* u */
	{
		0xFE,	/* ʒʐMwIDtB[h */
		{ MAKER_CODE },	/* [J[R[h */
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, },	/* j[NID([J[Ǝ) */
	},
	0x0000,	/* ُe */
	{ MAKER_CODE },	/* [J[R[h */
};

/* ʏƖNX */
struct general_lighting_t general_lighting_class_data = {
	0x30,	/*  */
	0x41,	/* _[hݒ */
	0x00,	/* ݒuꏊ */
	{ 0x00, 0x00, 'C', 0x00 },	/* Kiu */
	0x41,	/* ُ픭 */
	{ MAKER_CODE },	/* [J[R[h */
};

/*
 * ON/OFFݒ֐i0x30, 0x31̂ݎ󂯕tj
 */
int onoff_prop_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	/* TCYPȊO͎󂯕tȂ */
	if(size != 1)
		return 0;

	*anno = *((uint8_t*)item->exinf) != *((uint8_t*)src);

	switch(*(uint8_t *)src){
	/* ON̏ꍇ */
	case 0x30:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		/* 7seg"."ON */
		sil_wrb_mem((uint8_t *)0xFFFFF412, sil_reb_mem((uint8_t *)0xFFFFF412) & ~0x80);
		break;
	/* OFF̏ꍇ */
	case 0x31:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		/* 7seg"."OFF */
		sil_wrb_mem((uint8_t *)0xFFFFF412, sil_reb_mem((uint8_t *)0xFFFFF412) | 0x80);
		break;
	/* 0x300x31ȊO͎󂯕tȂ */
	default:
		return 0;
	}

	return 1;
}

/*
 * ُeݒ֐
 */
int node_profile_object_fault_content_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	/* TCY2ȊO͎󂯕tȂ */
	if(size != 2)
		return 0;

	if((*(uint16_t *)src >= 0x0) && (*(uint16_t *)src <= 0x3ec)){
		*((uint16_t *)item->exinf) = *((uint16_t *)src);
		/* TODO: ̂̏ꍇ̏*/
	}
	/* LȊO͎󂯕tȂ */
	else{
		return 0;
	}

	return 2;
}

/*
 * _[hݒݒ֐
 */
int general_lighting_lighting_mode_setting_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	uint8_t sseg = sil_reb_mem((uint8_t *)0xFFFFF412) & 0x80;

	/* TCY1ȊO͎󂯕tȂ */
	if(size != 1)
		return 0;

	switch(*(uint8_t *)src){
	/* ̏ꍇ */
	case 0x41:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		/* 7seg"A"ƕ\ */
		sil_wrb_mem((uint8_t *)0xFFFFF412, sseg | 0x08);
		break;
	/* ʏ퓔̏ꍇ */
	case 0x42:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		/* 7seg"b"ƕ\ */
		sil_wrb_mem((uint8_t *)0xFFFFF412, sseg | 0x03);
		break;
	/* 铔̏ꍇ */
	case 0x43:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		/* 7seg"C"ƕ\ */
		sil_wrb_mem((uint8_t *)0xFFFFF412, sseg | 0x46);
		break;
	/* J[̏ꍇ */
	case 0x45:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		/* 7seg"E"ƕ\ */
		sil_wrb_mem((uint8_t *)0xFFFFF412, sseg | 0x06);
		break;
	default:
		/* LȊO͎󂯕tȂ */
		return 0;
	}

	return 1;
}

/*
 * ُ픭Ԑݒ֐i0x41, 0x42̂ݎ󂯕tj
 */
int alarm_prop_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	/* TCYPȊO͎󂯕tȂ */
	if(size != 1)
		return 0;

	*anno = *((uint8_t *)item->exinf) != *((uint8_t *)src);

	switch(*(uint8_t *)src){
	/* ُ픭̏ꍇ */
	case 0x41:
	/* ُ픭Ȃ̏ꍇ */
	case 0x42:
		*((uint8_t *)item->exinf) = *((uint8_t *)src);
		break;
	/* 0x410x42ȊO͎󂯕tȂ */
	default:
		return 0;
	}

	return 1;
}

/*
 * ݎݒ֐
 */
int time_prop_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	uint8_t *p_src;

	if(size != 2)
		return 0;

	/* ݏImF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) != 0)
		tslp_tsk(1);

	/* JE^~ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) | RC1CC2_RWAIT);

	/* JE^̃EGCgԂ̊mF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) == 0)
		tslp_tsk(1);

	/* ݒ */
	p_src = (uint8_t *)src;
	sil_wrb_mem(RC1HOUR, *p_src++);
	sil_wrb_mem(RC1MIN, *p_src++);
	sil_wrb_mem(RC1SEC, 0x00);

	/* JE^ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) & ~RC1CC2_RWAIT);

	return (intptr_t)p_src - (intptr_t)src;
}

/*
 * ݎ擾֐
 */
int time_prop_get(const EPRPINIB *item, void *dst, int size)
{
	uint8_t *p_dst;

	if(size != 2)
		return 0;

	/* ǂݏoImF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) != 0)
		tslp_tsk(1);

	/* JE^~ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) | RC1CC2_RWAIT);

	/* JE^̃EGCgԂ̊mF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) == 0)
		tslp_tsk(1);

	/* ݒ */
	p_dst = (uint8_t *)dst;
	*p_dst++ = sil_reb_mem(RC1HOUR);
	*p_dst++ = sil_reb_mem(RC1MIN);

	/* JE^ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) & ~RC1CC2_RWAIT);

	return (intptr_t)p_dst - (intptr_t)dst;
}

/*
 * ݔNݒ֐
 */
int date_prop_set(const EPRPINIB *item, const void *src, int size, bool_t *anno)
{
	uint8_t *p_src;

	if(size != 4)
		return 0;

	/* ݏImF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) != 0)
		tslp_tsk(1);

	/* JE^~ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) | RC1CC2_RWAIT);

	/* JE^̃EGCgԂ̊mF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) == 0)
		tslp_tsk(1);

	/* Nݒ */
	p_src = (uint8_t *)src;
	p_src++;	/* 20XX */
	sil_wrb_mem(RC1YEAR, *p_src++);
	sil_wrb_mem(RC1MONTH, *p_src++);
	sil_wrb_mem(RC1DAY, *p_src++);

	/* JE^ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) & ~RC1CC2_RWAIT);

	return (intptr_t)p_src - (intptr_t)src;
}

/*
 * ݔN擾֐
 */
int date_prop_get(const EPRPINIB *item, void *dst, int size)
{
	uint8_t *p_dst;

	if(size != 4)
		return 0;

	/* ǂݏoImF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) != 0)
		tslp_tsk(1);

	/* JE^~ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) | RC1CC2_RWAIT);

	/* JE^̃EGCgԂ̊mF */
	while((sil_reb_mem(RC1CC2) & RC1CC2_RWST) == 0)
		tslp_tsk(1);

	p_dst = (uint8_t *)dst;
	*p_dst++ = 0x20;
	*p_dst++ = sil_reb_mem(RC1YEAR);
	*p_dst++ = sil_reb_mem(RC1MONTH);
	*p_dst++ = sil_reb_mem(RC1DAY);

	/* JE^ݒ */
	sil_wrb_mem(RC1CC2, sil_reb_mem(RC1CC2) & ~RC1CC2_RWAIT);

	return (intptr_t)p_dst - (intptr_t)dst;
}

static void main_initialize();
static TMO main_get_timer();
static void main_progress(TMO interval);
static void main_recv_esv(T_EDATA *esv);
static void main_break_wait(uint8_t *brkdat, int32_t len);
static void main_timeout();

/*
 *  C^XN
 */
void main_task(intptr_t exinf)
{
	ER ret, ret2;
	SYSTIM prev, now;
	TMO timer;
	T_EDATA *esv;
	uint8_t brkdat[64];
	int32_t len;

	/* TINETN܂ő҂ */
	ret = tslp_tsk(1000);
	if(ret != E_TMOUT)
		return;

	/* ECHONET~hEFAN */
	ret = act_tsk(ECN_UDP_TASK);
	if(ret != E_OK)
		return;

	/*  */
	main_initialize();

	ret2 = get_tim(&now);
	if (ret2 != E_OK){
		syslog(LOG_ERROR, "get_tim");
		return;
	}

	for(;;){
		prev = now;

		/* ^C}[擾 */
		timer = main_get_timer();

		/* d҂ */
		ret = ecn_trcv_esv(&esv, timer);
		if ((ret != E_OK) && (ret != E_WBLK) && (ret != E_TMOUT)){
			syslog(LOG_ERROR, "ecn_trcv_esv");
			break;
		}

		ret2 = get_tim(&now);
		if (ret2 != E_OK){
			syslog(LOG_ERROR, "get_tim");
			break;
		}

		/* Ԍo */
		main_progress(now - prev);

		/* EchonetdM̏ꍇ */
		if (ret == E_OK) {
			/* EchonetdM */
			main_recv_esv(esv);

			/* ̈ */
			ret = ecn_rel_esv(esv);
			if (ret != E_OK){
				syslog(LOG_ERROR, "ecn_rel_esv");
				break;
			}
		}
		/* d҂̊荞݂̏ꍇ */
		else if (ret == E_WBLK) {
			/* d҂̊荞݃f[^擾 */
			ret = ecn_get_brk_dat(esv, brkdat, sizeof(brkdat), &len);
			if (ret != E_OK){
				syslog(LOG_ERROR, "ecn_get_brk_dat");
				break;
			}

			/* d҂̊荞ݏ */
			main_break_wait(brkdat, len);

			/* ̈ */
			ret = ecn_rel_esv(esv);
			if (ret != E_OK){
				syslog(LOG_ERROR, "ecn_rel_esv");
				break;
			}
		}

		/* ^CAEg */
		main_timeout();
	}
}

enum main_state_t{
	main_state_idle,
};

TMO main_timer = TMO_FEVR;
enum main_state_t main_state = main_state_idle;
bool_t main_btn1_state;
int main_btn1_count = 0;
bool_t main_btn2_state;
int main_btn2_count = 0;

/*
 * 
 */
static void main_initialize()
{
	uint8_t btn;

	/* 7seg"0"ƕ\ */
	sil_wrb_mem((uint8_t *)0xFFFFF412, 0xC0);

	/* 10msɃ{^ԂmF */
	main_state = main_state_idle;
	main_timer = 10;

	/* {^ԓǂݍ */
	btn = sil_reb_mem((uint8_t *)0xFFFFF413);
	main_btn1_state = (btn & 0x01) == 0;
	main_btn2_state = (btn & 0x10) == 0;
}

/*
 * ^C}[擾
 */
static TMO main_get_timer()
{
	return main_timer;
}

/*
 * Ԍo
 */
static void main_progress(TMO interval)
{
	if(main_timer == TMO_FEVR)
		return;

	main_timer -= interval;
	if(main_timer < 0){
		main_timer = 0;
	}
}

/*
 * EchonetdM
 */
static void main_recv_esv(T_EDATA *esv)
{
	ER ret;
	uint8_t epc;
	uint8_t pdc;
	uint8_t p_edt[256];
	T_ENUM_EPC enm;

	ret = ecn_itr_ini(&enm, esv);
	if(ret != E_OK){
		syslog(LOG_ERROR, "ecn_itr_ini");
		return;
	}

	for(;;) {
		while((ret = ecn_itr_nxt(&enm, &epc, &pdc, p_edt)) == E_OK) {
			switch (epc) {
			case 0x80:
				break;
			case 0x81:
				break;
			}
		}
		if(ret != E_BOVR){
			syslog(LOG_ERROR, "ecn_itr_nxt");
			break;
		}
		if(enm.is_eof)
			break;
	}
}

/*
 * d҂̊荞ݏ
 */
static void main_break_wait(uint8_t *brkdat, int32_t len)
{
	switch(main_state){
	case main_state_idle:
		break;
	}
}

static void main_btn1_change(bool_t push);
static void main_btn2_change(bool_t push);

/*
 * ^CAEg
 */
static void main_timeout()
{
	uint8_t btn;

	if(main_timer != 0)
		return;

	switch(main_state){
	case main_state_idle:
		/* 10msɃ{^ԂmF */
		main_timer = 10;

		/* {^ԓǂݍ */
		btn = sil_reb_mem((uint8_t *)0xFFFFF413);

		/* {^P̏ */
		if(((btn & 0x01) == 0) && !main_btn1_state){
			main_btn1_count++;
			if(main_btn1_count > 10){
				main_btn1_count = 0;
				main_btn1_state = true;

				main_btn1_change(true);
			}
		}
		else if(((btn & 0x01) != 0) && main_btn1_state){
			main_btn1_count++;
			if(main_btn1_count > 10){
				main_btn1_count = 0;
				main_btn1_state = false;

				main_btn1_change(false);
			}
		}
		else{
			main_btn1_count = 0;
		}

		/* {^Q̏ */
		if(((btn & 0x10) == 0) && !main_btn2_state){
			main_btn2_count++;
			if(main_btn2_count > 10){
				main_btn2_count = 0;
				main_btn2_state = true;

				main_btn2_change(true);
			}
		}
		else if(((btn & 0x10) != 0) && main_btn2_state){
			main_btn2_count++;
			if(main_btn2_count > 10){
				main_btn2_count = 0;
				main_btn2_state = false;

				main_btn2_change(false);
			}
		}
		else{
			main_btn2_count = 0;
		}
		break;
	}
}

enum lighting_mode_t{
	lighting_mode_auto,		/* ̏ꍇ */
	lighting_mode_normal,	/* ʏ퓔̏ꍇ */
	lighting_mode_night,	/* 铔̏ꍇ */
	lighting_mode_coler		/* J[̏ꍇ */
};
bool_t main_on = false;
enum lighting_mode_t main_mode = lighting_mode_auto;

/*
 * {^Pԕω
 */
static void main_btn1_change(bool_t push)
{
	ER ret;
	T_EDATA *esv;
	uint8_t p_edt[1];

	/* Ė߂ɏ */
	if(push)
		return;

	/* ON/OFFԂ̐؂ւ */
	main_on = !main_on;
	p_edt[0] = main_on ? 0x30 : 0x31;

	/* vpeBݒd쐬 */
	ret = ecn_esv_setc(&esv, GENERAL_LIGHTING_CLASS_EOBJ, 0x80, 1, p_edt);
	if(ret != E_OK){
		syslog(LOG_ERROR, "ecn_esv_setc");
		return;
	}

	/* dM */
	ecn_snd_esv(esv);
}

/*
 * {^Qԕω
 */
static void main_btn2_change(bool_t push)
{
	ER ret;
	T_EDATA *esv;
	uint8_t p_edt[1];

	/* Ė߂ɏ */
	if(push)
		return;

	/* _[h̐؂ւ */
	switch(main_mode){
	/* ̏ꍇ */
	case lighting_mode_auto:
		/* ʏ퓔ɕύX */
		main_mode = lighting_mode_normal;
		p_edt[0] = 0x42;
		break;
	/* ʏ퓔̏ꍇ */
	case lighting_mode_normal:
		/* 铔̏ꍇ */
		main_mode = lighting_mode_night;
		p_edt[0] = 0x43;
		break;
	/* 铔̏ꍇ */
	case lighting_mode_night:
		/* J[̏ꍇ */
		main_mode = lighting_mode_coler;
		p_edt[0] = 0x45;
		break;
	/* J[̏ꍇ */
	case lighting_mode_coler:
	default:
		/* ̏ꍇ */
		main_mode = lighting_mode_auto;
		p_edt[0] = 0x41;
		break;
	}

	/* vpeBݒd쐬 */
	ret = ecn_esv_setc(&esv, GENERAL_LIGHTING_CLASS_EOBJ, 0xB6, 1, p_edt);
	if(ret != E_OK){
		syslog(LOG_ERROR, "ecn_esv_setc");
		return;
	}

	/* dM */
	ecn_snd_esv(esv);
}

